=== plugins/paintops/colorsmudge/tests/CMakeLists.txt ===
include(KritaAddBrokenUnitTest)

kis_add_test(
    KisColorsmudgeOpTest.cpp
     $<TARGET_PROPERTY:kritatestsdk,SOURCE_DIR>/stroke_testing_utils.cpp
    TEST_NAME KisColorsmudgeOpTest
    LINK_LIBRARIES kritalibpaintop kritaimage kritatestsdk
    NAME_PREFIX "plugins-colorsmudge-")
